/// <reference types="react" />
import { IObservable } from 'mobx';
import { observer } from 'mobx-react';
export interface ICansModel {
    namespace: string;
    protected?: boolean;
    observable: (app: Cans) => IObservable | IObservable;
}
export interface ICansModelObject {
    [namespace: string]: IObservable;
}
export interface ICansPluginObject {
    [namespace: string]: any;
}
export interface ICansPlugin {
    namespace: string;
    protected?: boolean;
    observable: (app: Cans) => any;
}
export declare class Cans {
    private __routerComponent;
    private __mountedRoot?;
    private __plugins;
    private __pluginsObject;
    private __models;
    private __modelsObject;
    private __getInjectList();
    readonly models: ICansModelObject;
    readonly plugins: ICansPluginObject;
    route(routeFunc: () => JSX.Element): void;
    model(model: ICansModel): void;
    start(el: HTMLElement): void;
    use(plugin: ICansPlugin): void;
}
declare const createCansApp: () => Cans;
export declare const inject: (view: any) => any;
export { observer };
export default createCansApp;
